<?php
/*
Plugin Name: Advanced Featured Post Widget
Plugin URI: http://wasistlos.waldemarstoffel.com/plugins-fur-wordpress/advanced-featured-post-widget
Description: The Advanced Featured Post Widget is yet another plugin to make your blog a bit more newspaper-like. Just by entering the ID, you can put a post in the 'featured' area and display thumbnail, headline, excerpt or all three of them (if available) in the fully customizable widget. It just has more options than the the Featured Post Widget.
Version: 1.6
Author: Waldemar Stoffel
Author URI: http://www.waldemarstoffel.com
License: GPL3
*/

/*  Copyright 2011  Waldemar Stoffel  (email : w-stoffel@gmx.net)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

*/


/* Stop direct call */

if(preg_match('#' . basename(__FILE__) . '#', $_SERVER['PHP_SELF'])) { die("Sorry, you don't have direct access to this page."); }


/* attach JavaScript file for textarea reszing */

$afpw_path = WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__)).'/';

function afpw_js_sheet() {
   global $afpw_path;
   wp_enqueue_script('ta-resize-script', $afpw_path.'ta-expander.js', false, false, true);
}

add_action('admin_print_scripts-widgets.php', 'afpw_js_sheet');

//Additional links on the plugin page

add_filter('plugin_row_meta', 'afpw_register_links',10,2);

function afpw_register_links($links, $file) {
	
	$base = plugin_basename(__FILE__);
	if ($file == $base) {
		$links[] = '<a href="options-general.php?page=advanced-fpw-settings">'.__('Settings','advanced-fpw').'</a>';
		$links[] = '<a href="http://wordpress.org/extend/plugins/advanced-featured-post-widget/faq/" target="_blank">'.__('FAQ','advanced-fpw').'</a>';
		$links[] = '<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=4P2ACVGPHY7WU" target="_blank">'.__('Donate','advanced-fpw').'</a>';
	}
	
	return $links;

}
	

// extending the widget class
 
class Advanced_Featured_Post_Widget extends WP_Widget {
 
 function Advanced_Featured_Post_Widget() {
	 
	 $widget_opts = array( 'description' => __('You can feature a certain post in this widget and display it, where and however you want, in your widget areas. The ID of a backup post can be given to avoid dubble content. Define, on what pages the widget will show.', 'advanced-fpw') );
	 $control_opts = array( 'width' => 400 );

	 
	 parent::WP_Widget(false, $name = 'Advanced Featured Post', $widget_opts, $control_opts);
 }
 
function form($instance) {
	
// setup some default settings
    
	$defaults = array( 'homepage' => true, 'category' => true );
    
	$instance = wp_parse_args( (array) $instance, $defaults );
	
	$title = esc_attr($instance['title']);
	$thumb = esc_attr($instance['thumb']);
	$image = esc_attr($instance['image']);
	$article = esc_attr($instance['article']);
	$backup = esc_attr($instance['backup']);
	$width = esc_attr($instance['width']);
	$subtitle = esc_attr($instance['subtitle']);	
	$excerpt = esc_attr($instance['excerpt']);
	$readmore = esc_attr($instance['readmore']);
	$rmtext = esc_attr($instance['rmtext']);	
	$style = esc_attr($instance['style']);
	$homepage=esc_attr($instance['homepage']);
	$frontpage=esc_attr($instance['frontpage']);
	$page=esc_attr($instance['page']);
	$category=esc_attr($instance['category']);
	$single=esc_attr($instance['single']);
	$date=esc_attr($instance['date']);
	$tag=esc_attr($instance['tag']);
	$attachment=esc_attr($instance['attachment']);
	$taxonomy=esc_attr($instance['taxonomy']);
	$author=esc_attr($instance['author']);
	$search=esc_attr($instance['search']);
	$not_found=esc_attr($instance['not_found']);
	
	if (empty($style)) {
		
		$style_height=25;
	
	}
	
	else {
		
		$afpw_elements=str_replace(array("\r\n", "\n", "\r"), '|', $style);
		$style_height=count(explode('|', $afpw_elements))*21;
		
	}
	
	if (empty($excerpt)) {
		
		$excerpt_height=25;
	
	}
	
	else {
		
		$afpw_elements=str_replace(array("\r\n", "\n", "\r"), '|', $excerpt);
		$excerpt_height=count(explode('|', $afpw_elements))*21;
		
	}
 
 ?>
 
<p>
 <label for="<?php echo $this->get_field_id('title'); ?>">
 <?php _e('Title:', 'advanced-fpw'); ?>
 <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('article'); ?>">
 <?php _e('Give here the ID of the post, you want to appear in the widget:', 'advanced-fpw'); ?>
 <input size="6" id="<?php echo $this->get_field_id('article'); ?>" name="<?php echo $this->get_field_name('article'); ?>" type="text" value="<?php echo $article; ?>" />
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('backup'); ?>">
 <?php _e('Give here the ID of the backup post, it will appear, when a single post page shows the featured article:', 'advanced-fpw'); ?>
 <input size="6" id="<?php echo $this->get_field_id('backup'); ?>" name="<?php echo $this->get_field_name('backup'); ?>" type="text" value="<?php echo $backup; ?>" />
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('image'); ?>">
 <input id="<?php echo $this->get_field_id('image'); ?>" name="<?php echo $this->get_field_name('image'); ?>" <?php if(!empty($image)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Check to get the first image of the post as thumbnail.', 'advanced-fpw'); ?>
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('width'); ?>">
 <?php _e('This is the width in px of the thumbnail (if choosing the first image):', 'advanced-fpw'); ?>
 <input size="4" id="<?php echo $this->get_field_id('width'); ?>" name="<?php echo $this->get_field_name('width'); ?>" type="text" value="<?php echo $width; ?>" />
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('thumb'); ?>">
 <input id="<?php echo $this->get_field_id('thumb'); ?>" name="<?php echo $this->get_field_name('thumb'); ?>" <?php if(!empty($thumb)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Check to <strong>not</strong> display the thumbnail of the post.', 'advanced-fpw'); ?>
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('subtitle'); ?>">
 <input id="<?php echo $this->get_field_id('subtitle'); ?>" name="<?php echo $this->get_field_name('subtitle'); ?>" <?php if(!empty($subtitle)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Check to display the title of the post <strong>under</strong> the thumbnail (it is above by default).', 'advanced-fpw'); ?>
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('excerpt'); ?>">
 <?php _e('If the excerpt of the post is not defined, by default the first 3 sentences of the post are showed. You can enter your own excerpt here, if you want.', 'advanced-fpw'); ?>
 <textarea class="widefat expand<?php echo $excerpt_height; ?>-1000" id="<?php echo $this->get_field_id('excerpt'); ?>" name="<?php echo $this->get_field_name('excerpt'); ?>"><?php echo $excerpt; ?></textarea>
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('readmore'); ?>">
 <input id="<?php echo $this->get_field_id('readmore'); ?>" name="<?php echo $this->get_field_name('readmore'); ?>" <?php if(!empty($readmore)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Check to have an additional &#39;read more&#39; link at the end of the excerpt.', 'advanced-fpw'); ?>
 </label>
</p>
<p>
 <label for="<?php echo $this->get_field_id('rmtext'); ?>">
 <?php _e('Write here some text for the &#39;read more&#39; link. By default, it is [...]:', 'advanced-fpw'); ?>
 <input class="widefat" id="<?php echo $this->get_field_id('rmtext'); ?>" name="<?php echo $this->get_field_name('rmtext'); ?>" type="text" value="<?php echo $rmtext; ?>" />
 </label>
</p>
<p>
 <?php _e('Check, where you want to show the widget. By default, it is showing on the homepage and the category pages:', 'advanced-fpw'); ?>
</p>
<p>
 <label for="<?php echo $this->get_field_id('homepage'); ?>">
 <input id="<?php echo $this->get_field_id('homepage'); ?>" name="<?php echo $this->get_field_name('homepage'); ?>" <?php if(!empty($homepage)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Homepage', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('frontpage'); ?>">
 <input id="<?php echo $this->get_field_id('frontpage'); ?>" name="<?php echo $this->get_field_name('frontpage'); ?>" <?php if(!empty($frontpage)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Frontpage (e.g. a static page as homepage)', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('page'); ?>">
 <input id="<?php echo $this->get_field_id('page'); ?>" name="<?php echo $this->get_field_name('page'); ?>" <?php if(!empty($page)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('&#34;Page&#34; pages', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('category'); ?>">
 <input id="<?php echo $this->get_field_id('category'); ?>" name="<?php echo $this->get_field_name('category'); ?>" <?php if(!empty($category)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Category pages', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('single'); ?>">
 <input id="<?php echo $this->get_field_id('single'); ?>" name="<?php echo $this->get_field_name('single'); ?>" <?php if(!empty($single)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Single post pages', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('date'); ?>">
 <input id="<?php echo $this->get_field_id('date'); ?>" name="<?php echo $this->get_field_name('date'); ?>" <?php if(!empty($date)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Archive pages', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('tag'); ?>">
 <input id="<?php echo $this->get_field_id('tag'); ?>" name="<?php echo $this->get_field_name('tag'); ?>" <?php if(!empty($tag)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Tag pages', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('attachment'); ?>">
 <input id="<?php echo $this->get_field_id('attachment'); ?>" name="<?php echo $this->get_field_name('attachment'); ?>" <?php if(!empty($attachment)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Attachments', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('taxonomy'); ?>">
 <input id="<?php echo $this->get_field_id('taxonomy'); ?>" name="<?php echo $this->get_field_name('taxonomy'); ?>" <?php if(!empty($taxonomy)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Custom Taxonomy pages (only available, if having a plugin)', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('author'); ?>">
 <input id="<?php echo $this->get_field_id('author'); ?>" name="<?php echo $this->get_field_name('author'); ?>" <?php if(!empty($author)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Author pages', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('search'); ?>">
 <input id="<?php echo $this->get_field_id('search'); ?>" name="<?php echo $this->get_field_name('search'); ?>" <?php if(!empty($search)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('Search Results', 'advanced-fpw'); ?>
 </label><br />
 <label for="<?php echo $this->get_field_id('not_found'); ?>">
 <input id="<?php echo $this->get_field_id('not_found'); ?>" name="<?php echo $this->get_field_name('not_found'); ?>" <?php if(!empty($not_found)) {echo "checked=\"checked\""; } ?> type="checkbox" />&nbsp;<?php _e('&#34;Not Found&#34;', 'advanced-fpw'); ?>
 </label><br />
</p>
<p>
 <label for="<?php echo $this->get_field_id('style'); ?>">
 <?php _e('Here you can finally style the widget. Simply type something like<br /><strong>border: 2px solid;<br />border-color: #cccccc;<br />padding: 10px;</strong><br />to get just a gray outline and a padding of 10 px. If you leave that section empty, your theme will style the widget.', 'advanced-fpw'); ?>
 <textarea class="widefat expand<?php echo $style_height; ?>-1000" id="<?php echo $this->get_field_id('style'); ?>" name="<?php echo $this->get_field_name('style'); ?>"><?php echo $style; ?></textarea>
 </label>
</p>
<?php
 }
 


function update($new_instance, $old_instance) {
	 
	 $instance = $old_instance;
	 
	 $instance['title'] = strip_tags($new_instance['title']);
	 $instance['article'] = strip_tags($new_instance['article']);
	 $instance['backup'] = strip_tags($new_instance['backup']);	 
	 $instance['thumb'] = strip_tags($new_instance['thumb']);	 
	 $instance['image'] = strip_tags($new_instance['image']);	 
	 $instance['width'] = strip_tags($new_instance['width']);	 
	 $instance['subtitle'] = strip_tags($new_instance['subtitle']);
	 $instance['excerpt'] = strip_tags($new_instance['excerpt']);
	 $instance['readmore'] = strip_tags($new_instance['readmore']);
	 $instance['rmtext'] = strip_tags($new_instance['rmtext']);	 
	 $instance['style'] = strip_tags($new_instance['style']);
	 $instance['homepage'] = strip_tags($new_instance['homepage']);
	 $instance['frontpage'] = strip_tags($new_instance['frontpage']);
	 $instance['page'] = strip_tags($new_instance['page']);
	 $instance['category'] = strip_tags($new_instance['category']);
	 $instance['single'] = strip_tags($new_instance['single']);
	 $instance['date'] = strip_tags($new_instance['date']); 
	 $instance['tag'] = strip_tags($new_instance['tag']);
	 $instance['attachment'] = strip_tags($new_instance['attachment']);
	 $instance['taxonomy'] = strip_tags($new_instance['taxonomy']);
	 $instance['author'] = strip_tags($new_instance['author']);
	 $instance['search'] = strip_tags($new_instance['search']);
	 $instance['not_found'] = strip_tags($new_instance['not_found']);

	 return $instance;
}
 
function widget($args, $instance) {
	
// get the type of page, we're actually on

if (is_front_page()) $afpw_pagetype='frontpage';
if (is_home()) $afpw_pagetype='homepage';
if (is_page()) $afpw_pagetype='page';
if (is_category()) $afpw_pagetype='category';
if (is_single()) $afpw_pagetype='single';
if (is_date()) $afpw_pagetype='date';
if (is_tag()) $afpw_pagetype='tag';
if (is_attachment()) $afpw_pagetype='attachment';
if (is_tax()) $afpw_pagetype='taxonomy';
if (is_author()) $afpw_pagetype='author';
if (is_search()) $afpw_pagetype='search';
if (is_404()) $afpw_pagetype='not_found';

// display only, if said so in the settings of the widget

if ($instance[$afpw_pagetype]) {
	
	// the widget is displayed	
	extract( $args );
	
	$title = apply_filters('widget_title', $instance['title']);
	
	if (empty($instance['style'])) {
		
		$afpw_before_widget=$before_widget;
		$afpw_after_widget=$after_widget;
		
	}
	
	else {
		
		$style=str_replace(array("\r\n", "\n", "\r"), '', $instance['style']);
		
		$afpw_before_widget="<div id=\"".$widget_id."\" style=\"".$style."\">";
		$afpw_after_widget="</div>";
		
	}
	
	echo $afpw_before_widget;
	
	if ( $title ) {
		
		echo $before_title . $title . $after_title;
		
	}
	
	$afpw_options = get_option('afpw_options');

	if (count ($afpw_options)!=0 && !empty ($afpw_options)) {
	
		$afpw_class=" class=\"afpwlink\"";
		
		$afpw_stylesheet = WP_PLUGIN_DIR . '/advanced-featured-post-widget/advanced-fpw.css';	
		$afpw_css_content = file_get_contents($afpw_stylesheet);
	
		if (empty($afpw_css_content)) {
		
			afpw_write_stylesheet($afpw_options); }
	
	}
	
	global $wp_query;
		
	$afpw_post_id = get_post($instance['article']);
	$afpw_post_name = $afpw_post_id->post_name;
	
	if ($instance['article'] == $wp_query->get( 'p' ) || $afpw_post_name == $wp_query->get ( 'name' )) { $afpw_post = 'p='.$instance['backup']; }
	
	else { $afpw_post = 'p='.$instance['article']; }
 
/* This is the actual function of the plugin, it fills the widget with the customized post */

 global $post;
 $afpw_posts = get_posts($afpw_post);
 foreach($afpw_posts as $post) :
 
   setup_postdata($post);
   
   // post tile above thumbnail
   
   if (!$instance['subtitle']) {
	   
	   ?>
       <p>
       <a href="<?php the_permalink(); ?>" <?php echo $afpw_class; ?>><?php the_title(); ?></a>
       </p>
	   <?php
   
   }
   
   // thumbnail, if wanted
   
   if ($instance['image']) {
	   
	   $afpw_thumb = '';
	   
	   $afpw_image = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
	   $afpw_thumb = $matches [1] [0];
	   
	   if ($afpw_thumb) {
	   
	   $afpw_image_title=$post->get_the_title;
	   $afpw_size=getimagesize($afpw_thumb);
	   $afpw_x=$instance['width'];
	   $afpw_y=intval($afpw_size[1]/($afpw_size[0]/$afpw_x));
	   
	   ?>
       <a href="<?php the_permalink(); ?>">
	   <?php echo '<img title="'.$afpw_image_title.'" src="'.$afpw_thumb.'" alt="'.$afpw_image_title.'" width="'.$afpw_x.'" height="'.$afpw_y.'" />'; ?>
       </a>
	   <?php
	
   }}
   
   else {
	   
   if (function_exists('has_post_thumbnail')) {
	   
	   if (has_post_thumbnail() && !$instance['thumb']) {
		   
		   ?>
           <a href="<?php the_permalink(); ?>">
		   <?php the_post_thumbnail(); ?>
           </a>
		   <?php
		
	   }}
       
    }
	
	// post title beneath thumbnail
	
	if ($instance['subtitle']) {
	   
	   ?>
       <p>
       <a href="<?php the_permalink(); ?>" <?php echo $afpw_class; ?>><?php the_title(); ?></a>
       </p>
	   <?php 
   
   }	

		   
/* show the excerpt of the post */
	
	$afpw_excerpt=$instance['excerpt'];
	
	if (!$afpw_excerpt) {
		
		$afpw_excerpt=$post->post_excerpt;
		
	}
	
/* in case the excerpt is not definded by theme or anything else, the first 3 sentences of the content are given */
	
	if (!$afpw_excerpt) {
		
		$afpw_text=preg_replace('/\[caption(.*?)\[\/caption\]/', '', get_the_content());
		
		$afpw_short=array_slice(preg_split("/([\t.!?]+)/", $afpw_text, -1, PREG_SPLIT_DELIM_CAPTURE), 0, 6);
			
		$afpw_excerpt=implode($afpw_short);
	
	}
	
	echo '<p>'.$afpw_excerpt;
	
/* do we want the read more link and do we have text for it? */

	if ($instance['readmore']) {
		
		$afpw_rmtext=$instance['rmtext'];
		
		if (!$afpw_rmtext) $afpw_rmtext='[...]';
		
		echo ' <a href="';
		
		the_permalink();
		
		echo '">'.$afpw_rmtext.'</a>';
		
	}
		
	echo '</p>';
	
	endforeach;

 
 echo $afpw_after_widget;
 
 }}
 
}

// writing css to file
	
function afpw_write_stylesheet($afpw_styles) {
	
	$afpw_link=str_replace(array("\r\n", "\n", "\r"), '', $afpw_styles['link']);
	$afpw_hover=str_replace(array("\r\n", "\n", "\r"), '', $afpw_styles['hover']);
	
	$afpw_stylesheet = WP_PLUGIN_DIR . '/advanced-featured-post-widget/advanced-fpw.css';
	
	$afpw_link_style=".afpwlink {".$afpw_link."}\r\n.afpwlink:hover {".$afpw_hover."}";
	
	$fp = fopen( $afpw_stylesheet, "w" );
	fwrite ($fp, $afpw_link_style);
	fclose ($fp);
	
}

add_action('widgets_init', create_function('', 'return register_widget("Advanced_Featured_Post_Widget");'));


// import laguage files

load_plugin_textdomain('advanced-fpw', false , basename(dirname(__FILE__)).'/languages');

// init

add_action('admin_init', 'afpw_init');

function afpw_init() {
	
	register_setting( 'afpw_options', 'afpw_options', 'afpw_validate' );
	
	add_settings_section('afpw_settings', __('Styling of the links', 'advanced-fpw'), 'afpw_display_section', 'afpw_styles');
	
	add_settings_field('afpw_link_style', __('Link style:', 'advanced-fpw'), 'afpw_link_field', 'afpw_styles', 'afpw_settings');
	
	add_settings_field('afpw_hover_style', __('Hover style:', 'advanced-fpw'), 'afpw_hover_field', 'afpw_styles', 'afpw_settings');

}

function afpw_display_section() {
	
	echo '<p>'.__('Just put some css code here.', 'advanced-fpw').'</p>';

}

function afpw_link_field() {
	
	$afpw_options = get_option('afpw_options');
	
	echo "<textarea id=\"afpw_link\" name=\"afpw_options[link]\" rows=\"5\" cols=\"35\"  />".$afpw_options['link']."</textarea>";
	
}

function afpw_hover_field() {
	
	$afpw_options = get_option('afpw_options');
	
	echo "<textarea id=\"afpw_hover\" name=\"afpw_options[hover]\" rows=\"5\" cols=\"35\"  />".$afpw_options['hover']."</textarea>";
	
}

// Cleaning on deactivation

register_deactivation_hook(  __FILE__, 'unset_afpw' );

function unset_afpw() {
	
	delete_option('afpw_options');
	
}

// Installing options page

add_action('admin_menu', 'afpw_admin_menu');

function afpw_admin_menu() {
	
	add_options_page(__('Advanced FP Settings', 'advanced-fpw'), 'Advanced Featured Post Widget', 'administrator', 'advanced-fpw-settings', 'advanced_fpw_options_page');
	
}

// Calling the options page

function advanced_fpw_options_page() {
	
	?>
    
    <div>
    <h2><?php _e('Advanced Featured Post Widget Settings', 'advanced-fpw'); ?></h2>
    
	<?php _e('Style the links of the widget. If you leave this empty, your theme will style the hyperlinks.', 'advanced-fpw'); ?>
    <p><?php _e('Just input something like,', 'advanced-fpw'); ?>
    <p><strong>font-weight: bold;<br />
    color: #0000ff;<br />
    text-decoration: underline;    
    </strong></p>
    <?php _e('to get fat, blue, underlined links.', 'advanced-fpw'); ?></p>
    <p><strong><?php _e('You most probably have to use &#34;!important&#34; at the end of each line, to make it work.', 'advanced-fpw'); ?></strong></p>
    
    <form action="options.php" method="post">
	
	<?php
    
	settings_fields('afpw_options');
	do_settings_sections('afpw_styles');
	
	?>
    
    <input name="Submit" type="submit" value="<?php esc_attr_e('Save Changes'); ?>" />
    </form></div>
	
	<?php
}

function afpw_validate($input) {
	
	$newinput['link']=trim($input['link']);
	$newinput['hover']=trim($input['hover']);
	
	afpw_write_stylesheet($newinput);
	
	return $newinput;

}

add_action ('wp_print_styles', 'afpw_css');

function afpw_css () {
	
	$afpw_options = get_option('afpw_options');
	
	if (count ($afpw_options)!=0 && !empty ($afpw_options)) {
		
        $afpw_css_Url = WP_PLUGIN_URL . '/advanced-featured-post-widget/advanced-fpw.css';
        $afpw_css_File = WP_PLUGIN_DIR . '/advanced-featured-post-widget/advanced-fpw.css';
        if ( file_exists($afpw_css_File) ) {
            wp_register_style('advanced-fpw', $afpw_css_Url);
            wp_enqueue_style( 'advanced-fpw');
			
		}
		
	}
	
}

?>